#include <string.h>

#include "types.h"
#include "x6502.h"

#include "fce.h"
#include "sound.h"
#include "svga.h"

#include "input.h"
static uint8 joy_readbit[2];
static uint8 joy[4]={0,0,0,0};

/* This function is a quick hack to get the NSF player to use emulated gamepad
   input.
*/

static int JPAttrib[2]={0,0};
int JPType[2];
static void *InputDataPtr[2];

void (*InputScanlineHook)(uint8 *bg, uint8 *spr, uint32 linets, int final);

static INPUTC DummyJPort={0,0,0,0,0};
static INPUTC *JPorts[2]={&DummyJPort,&DummyJPort};

static uint8 FP_FASTAPASS(1) ReadGP(int w)
{
    uint8 ret;
    
    if(joy_readbit[w]>=8)
        ret = ((joy[2+w]>>(joy_readbit[w]&7))&1);
    else
        ret = ((joy[w]>>(joy_readbit[w]))&1);

    if(joy_readbit[w]>=16) ret=0;
    if(joy_readbit[w]==19-w) ret|=1;

	joy_readbit[w]++;
    return ret;
}

static DECLFR(JPRead)
{
	uint8 ret=0;

	if(JPorts[A&1]->Read)
	 ret|=JPorts[A&1]->Read(A&1);

	ret|=X.DB&0xC0;
	return(ret);
}

static DECLFW(B4016)
{
	if(JPorts[0]->Write)
	 JPorts[0]->Write(V&1);
        if(JPorts[1]->Write)
         JPorts[1]->Write(V&1);

        if((PSG[0x16]&1) && (!(V&1)))
        {
	 /* This strobe code is just for convenience.  If it were
	    with the code in input / *.c, it would more accurately represent
	    what's really going on.  But who wants accuracy? ;)
	    Seriously, though, this shouldn't be a problem.
	 */
	 if(JPorts[0]->Strobe)
	  JPorts[0]->Strobe(0);
         if(JPorts[1]->Strobe)
          JPorts[1]->Strobe(1);
	 }
         PSG[0x16]=V;
}

static void FP_FASTAPASS(1) StrobeGP(int w)
{
	joy_readbit[w]=0;
}

static INPUTC GPC={ReadGP,0,StrobeGP,0,0,0};

void FCEU_UpdateInput(void)
{
	int x=0;

//	for(x=0;x<2;x++)
//	{
    //  if(!x)
    //  {
            joy[0]=*(uint32 *)InputDataPtr[0];
            joy[2]=*(uint32 *)InputDataPtr[0] >> 16;
    //  }
    //  else
    //  {
    //  joy[1]=*(uint32 *)InputDataPtr[1] >>8;
    //  joy[3]=*(uint32 *)InputDataPtr[1] >>24;
    //  }
//	}
}

static void SLHLHook(uint8 *bg, uint8 *spr, uint32 linets, int final)
{
 int x;

// for(x=0;x<2;x++)
  if(JPorts[x]->SLHook)
   JPorts[x]->SLHook(x,bg,spr,linets,final);
}

static void CheckSLHook(void)
{
    InputScanlineHook=0;
    
    if(JPorts[0]->SLHook || JPorts[1]->SLHook)
        InputScanlineHook=SLHLHook;
}

static void FASTAPASS(1) SetInputStuff(int x)
{
    switch(JPType[x])
    {
        case SI_GAMEPAD:
            JPorts[x]=&GPC;
            break;
        case SI_NONE:
            JPorts[x]=&DummyJPort;
            break;
    }
    CheckSLHook();
}

// VS Unisystem code called after SetInputMap() hooks B4016.  Need to
// rewrite code to make this more sane?

void InitializeInput(void)
{ 
	memset(joy_readbit,0,sizeof(joy_readbit));
    memset(joy,0,sizeof(joy));

    SetReadHandler(0x4016,0x4017,JPRead);
    SetWriteHandler(0x4016,0x4016,B4016);

    SetInputStuff(0);
    SetInputStuff(1);
}

void FCEUI_SetInput(int port, int type, void *ptr, int attrib)
//void FCEUI_SetInput(int port, int type, int attrib)
{
    JPAttrib[port]=attrib;
    JPType[port]=type;
    InputDataPtr[port]=ptr;
    SetInputStuff(port);
}
