#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sega_int.h>
#include <sega_sys.h>
#include <sega_mth.h>
#include <machine.h>
#include "sega_per.h"
#include "per_x.h"        
#include "../drivers/cli/main.h"
#include "../types.h"
#include "shared.h"

 //MMC1 megaman
 //MMC3 mario2
 //MMC5 castlevania3

#define WIDTH (256+16)
#define HEIGHT 240

//#define TEST 1

static int ntsctint=46+10;
static int ntschue=72;
static int ntsccol=0;
static unsigned int play=0;

#define M_PI 3.14159265358979323846
//typedef unsigned char byte;

typedef struct {
	Uint8 r,g,b;
} pal;

byte *base_rom;
//byte base_rom[0x20000];
byte *XBuf;
Uint16 *saturn_palette;

pal *palo;
//int joy[4];
extern int MMC5Hack;
unsigned long JSreturn;
static int JoySwap=0;
//static int JPAttrib[2]={0,0};
//int JPType[2]={0,0};
//static void *InputDataPtr[2];
//static int FSkip=3;
SysPort *__port;
const SysDevice	*device;
trigger_t	pltrigger[2],pltriggerE[2];

unsigned int frame_x=0;
//VBT passage en satic peut poser problme ?
static unsigned int frame_y=0;

/* Default palette */
pal palette[64] = {

        { 0x1D>>1, 0x1D>>1, 0x1D>>1 }, /* Value 0 */
        { 0x09>>1, 0x06>>1, 0x23>>1 }, /* Value 1 */
        { 0x00>>1, 0x00>>1, 0x2A>>1 }, /* Value 2 */
        { 0x11>>1, 0x00>>1, 0x27>>1 }, /* Value 3 */
        { 0x23>>1, 0x00>>1, 0x1D>>1 }, /* Value 4 */
        { 0x2A>>1, 0x00>>1, 0x04>>1 }, /* Value 5 */
        { 0x29>>1, 0x00>>1, 0x00>>1 }, /* Value 6 */
        { 0x1F>>1, 0x02>>1, 0x00>>1 }, /* Value 7 */
        { 0x10>>1, 0x0B>>1, 0x00>>1 }, /* Value 8 */
        { 0x00>>1, 0x11>>1, 0x00>>1 }, /* Value 9 */
        { 0x00>>1, 0x14>>1, 0x00>>1 }, /* Value 10 */
        { 0x00>>1, 0x0F>>1, 0x05>>1 }, /* Value 11 */
        { 0x06>>1, 0x0F>>1, 0x17>>1 }, /* Value 12 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 13 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 14 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 15 */
        { 0x2F>>1, 0x2F>>1, 0x2F>>1 }, /* Value 16 */
        { 0x00>>1, 0x1C>>1, 0x3B>>1 }, /* Value 17 */
        { 0x08>>1, 0x0E>>1, 0x3B>>1 }, /* Value 18 */
        { 0x20>>1, 0x00>>1, 0x3C>>1 }, /* Value 19 */
        { 0x2F>>1, 0x00>>1, 0x2F>>1 }, /* Value 20 */
        { 0x39>>1, 0x00>>1, 0x16>>1 }, /* Value 21 */
        { 0x36>>1, 0x0A>>1, 0x00>>1 }, /* Value 22 */
        { 0x32>>1, 0x13>>1, 0x03>>1 }, /* Value 23 */
        { 0x22>>1, 0x1C>>1, 0x00>>1 }, /* Value 24 */
        { 0x00>>1, 0x25>>1, 0x00>>1 }, /* Value 25 */
        { 0x00>>1, 0x2A>>1, 0x00>>1 }, /* Value 26 */
        { 0x00>>1, 0x24>>1, 0x0E>>1 }, /* Value 27 */
        { 0x00>>1, 0x20>>1, 0x22>>1 }, /* Value 28 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 29 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 30 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 31 */
        { 0x3F>>1, 0x3F>>1, 0x3F>>1 }, /* Value 32 */
        { 0x0F>>1, 0x2F>>1, 0x3F>>1 }, /* Value 33 */
        { 0x17>>1, 0x25>>1, 0x3F>>1 }, /* Value 34 */
        { 0x10>>1, 0x22>>1, 0x3F>>1 }, /* Value 35 */
        { 0x3D>>1, 0x1E>>1, 0x3F>>1 }, /* Value 36 */
        { 0x3F>>1, 0x1D>>1, 0x2D>>1 }, /* Value 37 */
        { 0x3F>>1, 0x1D>>1, 0x18>>1 }, /* Value 38 */
        { 0x3F>>1, 0x26>>1, 0x0E>>1 }, /* Value 39 */
        { 0x3C>>1, 0x2F>>1, 0x0F>>1 }, /* Value 40 */
        { 0x20>>1, 0x34>>1, 0x04>>1 }, /* Value 41 */
        { 0x13>>1, 0x37>>1, 0x12>>1 }, /* Value 42 */
        { 0x16>>1, 0x3E>>1, 0x26>>1 }, /* Value 43 */
        { 0x00>>1, 0x3A>>1, 0x36>>1 }, /* Value 44 */
        { 0x1E>>1, 0x1E>>1, 0x1E>>1 }, /* Value 45 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 46 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 47 */
        { 0x3F>>1, 0x3F>>1, 0x3F>>1 }, /* Value 48 */
        { 0x2A>>1, 0x39>>1, 0x3F>>1 }, /* Value 49 */
        { 0x31>>1, 0x35>>1, 0x3F>>1 }, /* Value 50 */
        { 0x35>>1, 0x32>>1, 0x3F>>1 }, /* Value 51 */
        { 0x3F>>1, 0x31>>1, 0x3F>>1 }, /* Value 52 */
        { 0x3F>>1, 0x31>>1, 0x36>>1 }, /* Value 53 */
        { 0x3F>>1, 0x2F>>1, 0x2C>>1 }, /* Value 54 */
        { 0x3F>>1, 0x36>>1, 0x2A>>1 }, /* Value 55 */
        { 0x3F>>1, 0x39>>1, 0x28>>1 }, /* Value 56 */
        { 0x38>>1, 0x3F>>1, 0x28>>1 }, /* Value 57 */
        { 0x2A>>1, 0x3C>>1, 0x2F>>1 }, /* Value 58 */
        { 0x2C>>1, 0x3F>>1, 0x33>>1 }, /* Value 59 */
        { 0x27>>1, 0x3F>>1, 0x3C>>1 }, /* Value 60 */
        { 0x31>>1, 0x31>>1, 0x31>>1 }, /* Value 61 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 62 */
        { 0x00>>1, 0x00>>1, 0x00>>1 }, /* Value 63 */
};


/* _CRT0_FLAG_LOCK_MEMORY might not always result in all memory being locked.
   Bummer.  I'll add code to explicitly lock the data touched by the sound
   interrupt handler(and the handler itself), if necessary(though that might
   be tricky...).  I'll also to cover the data the keyboard
   interrupt handler touches.
*/

//int _crt0_startup_flags = _CRT0_FLAG_FILL_SBRK_MEMORY | _CRT0_FLAG_LOCK_MEMORY | _CRT0_FLAG_USE_DOS_SLASHES;

//static int f8bit=0;
//int soundo=44100;
//int doptions=0;

void FCEUD_SetPalette(Uint8 index, Uint8 r, Uint8 g, Uint8 b);
//void FCEUI_SetInput(int port);
void FCEUI_SetInput(int port, int type, void *ptr, int attrib);
void WritePalette(void);
void InitCD();
void ClrVram(volatile Uint8 *buff);
Uint32 update_input(void);

void ss_main(void);
//---------------------------------------------------------------------------------------------
int main(void)
{
    Uint8	*dst;
    
    // 1.Zero Set .bss Section
    for (dst = (Uint8 *)&_bstart; dst < (Uint8 *)&_bend; dst++)
    {
    	*dst = 0;
    }
	SYS_CHGSYSCK(1);             //28mhz
	set_imask(0); 
    ss_main();
    return 0;
}
//---------------------------------------------------------------------------------------------
void ss_main(void)
{
	base_rom         = (byte *) 0x00202000;
	XBuf             = (Uint8 *)SCL_VDP2_VRAM_A0;
    MMC5Hack         = 1;
    palo             = palette;
//    FSkip            = 3;
    //maxsprites       = 8; // pas de limite=64
    saturn_palette   = (Uint16 *)((Uint32)SCL_COLRAM_ADDR) ;
    FCEUI_SetInput(0, 1, &JSreturn, 0);
 
 /*
 void FCEUI_SetInput(int port, int type, void *ptr, int attrib)
{
 JPAttrib[port]=attrib;
 JPType[port]=type;
 InputDataPtr[port]=ptr;
 SetInputStuff(port);
}
 */
 
	InitCD();
	*(volatile Uint16 *)0x25F80000 &= 0x7fff;
	set_imask(0);
	
    SCL_Vdp2Init();
    InitDisplay();
    
    ChangeDir("GAMES");

//    SCL_SetBack((volatile)(SCL_VDP2_VRAM+0x80000-2),1,49);     
    CLImain();
return (0);
}
//---------------------------------------------------------------------------------------------
void InitDisplay()
{
	unsigned short  i = 0;
	
    Uint16			cyclePat[] =
/*	{
		0x4444, 0xeeee,		// NBG0 - 512x512 bitmap - 256 colours - bank A 
		0x4444, 0xeeee,
		0x5555, 0xeeee,		// NBG1 - 512x512 bitmap - 256 colours - bank B 
		0x5555, 0xeeee					
	};		
*/
	{
		0x44ee, 0xeeee,		// NBG0 - 512x512 bitmap - 256 colours - bank A 
		0xeee, 0xeeee,
		0xff5e, 0xeeee,		// NBG1 - 512x512 bitmap - 256 colours - bank B 
		0xeeee, 0xeeee							
	};
	
    SclConfig	    config;
    SclVramConfig	vramConfig;

   	SCL_SetColRamMode(SCL_CRM15_1024);
	SetVblank();
	SCL_SetFrameInterval(-1);	
 	
    SCL_DisplayFrame();
    SCL_DisplayFrame();

    SCL_AllocColRam(SCL_NBG0,256,ON); 
//   	SCL_SetColRam(SCL_NBG0,0,256,palette);

//    SCL_AllocColRam(SCL_NBG1,16,ON); 
    SCL_SetColRam(SCL_NBG1,0,16,palette);
    
//    saturn_palette   = (Uint16 *)((Uint32)SCL_COLRAM_ADDR) ;

	SCL_SetPriority(SCL_NBG1,6);
	SCL_SetPriority(SCL_NBG0,5);
	
	SCL_SetBack((volatile)(SCL_VDP2_VRAM+0x80000-2),1,0);
	
	/* Configure VDP2 VRAM */
	SCL_InitVramConfigTb(&vramConfig);
	vramConfig.vramModeA = ON;
	vramConfig.vramModeB = ON;
	SCL_SetVramConfig(&vramConfig);

	SCL_InitConfigTb(&config);
	config.dispenbl 	 = ON;
	config.bmpsize 		 = SCL_BMP_SIZE_512X512;
	config.coltype 		 = SCL_COL_TYPE_256;//SCL_COL_TYPE_256;
	config.datatype 	 = SCL_BITMAP;
	config.mapover       = SCL_OVER_0;
	config.plate_addr[0] = SCL_VDP2_VRAM_A0;
	SCL_SetConfig(SCL_NBG0, &config);		  // jeu 

	SCL_InitConfigTb(&config);
/*config.dispenbl 	 = ON;
	config.bmpsize 		 = SCL_BMP_SIZE_512X512;
	config.coltype 		 = SCL_COL_TYPE_256;
	config.datatype 	 = SCL_BITMAP;
	config.mapover       = SCL_OVER_0;
	config.plate_addr[0] = SCL_VDP2_VRAM_B0;
	SCL_SetConfig(SCL_NBG1, &config);
*/	
	config.dispenbl 	 = ON;
	config.bmpsize 		 = SCL_BMP_SIZE_512X256;
	config.coltype 		 = SCL_COL_TYPE_16;//SCL_COL_TYPE_256;
	config.datatype 	 = SCL_BITMAP;
	config.mapover       = SCL_OVER_0;
	config.plate_addr[0] = SCL_VDP2_VRAM_B0;
	SCL_SetConfig(SCL_NBG1, &config);			 //fonte





	/*	VRAM Access Pattern Set            */
	SCL_SetCycleTable(cyclePat);		
	
    SCL_SetDisplayMode(SCL_NON_INTER,SCL_240LINE,SCL_NORMAL_A);	

	SCL_SetFrameInterval(1);	

	VDP2_InitVRAM();    
	
	PER_SMPC_RES_ENA();// Zbg{^L 
//	FNT_SetBuffSize(512,256,1);	
	
	SCL_Open(SCL_NBG0);
	SCL_MoveTo(FIXED(5), FIXED(-10),0);
//	SCL_Scale(FIXED(1), FIXED(1));
	SCL_Close();
	
    SCL_Open(SCL_NBG1);
	SCL_MoveTo(FIXED(0), FIXED(0),0);
//	SCL_Scale(FIXED(1.0), FIXED(1.0));
	SCL_Close();

	ClrVram((volatile Uint8 *)SCL_VDP2_VRAM_A0);
	ClrVram((volatile Uint8 *)SCL_VDP2_VRAM_B0);
	play=1;
}	

//--------------------------------------------------------------------------------------------------------------
void VDP2_InitVRAM(void)
{
	/* Variables. */
	Uint32	loop;
	Uint32	maxloop;

	/* Fascist clear of all VDP2 VRAM */
	loop = 0;
	maxloop = 512*1024;

	while (loop < maxloop)
	{
		*((Uint32 *) (SCL_VDP2_VRAM_A0 + loop)) = 0;
		loop += 4;
	}

	/* Now set layer NBG1 to be a nice blue colour */
	loop = 0;
	maxloop = BITMAP_PIXEL_WIDTH * BITMAP_PIXEL_HEIGHT;
}
//-------------------------------------------------------------------------------------------------------------------------------------

void	UsrVblankIn( void ){
//	SCL_VblankStart();

	unsigned char xx[4];
	SCL_ScrollShow2();

		frame_y++;

		if(frame_y==60)
		{
//				sprintf(xx,"%03d",frame_x);
				xx[0] = (frame_x/100)+'0';
				xx[1] = ((frame_x-((frame_x/100)*100))/10)+'0';
				xx[2]=  (frame_x %10)+'0';
				xx[3]=  '\0';
				FNT_Print256_2bpp((volatile Uint8 *)SCL_VDP2_VRAM_B0,
					(Uint8 *)xx,90,2);

//				FCEU_printf("FPS:%s/60",xx);

				frame_y=frame_x=0;
		}
}

//---------------------------------------------------------------------------------------------------------------
void   UsrVblankOut( void ){

	SCL_VblankEnd();
	__port = PER_OpenPort();
//		PER_GetPort(__port);	
	
}
//---------------------------------------------------------------------------------------------------------------
void	SetVblank( void ){
	
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT);
	INT_SetScuFunc(INT_SCU_VBLK_IN,UsrVblankIn);
	INT_SetScuFunc(INT_SCU_VBLK_OUT,UsrVblankOut);
	INT_ChgMsk(INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT,INT_MSK_NULL);
	__port = PER_OpenPort();
}
//-------------------------------------------------------------------------------------------------------------------------------------
void	ClrVram(volatile Uint8 *buff)
{
	Uint32	i;
	for(i=0;i<(512 * 256);i++)	buff[i]=0x00;
}
//-------------------------------------------------------------------------------------------------------------------------------------
void FCEUI_SetNTSCTH(int n, int tint, int hue)
{
    ntsctint=tint;
    ntschue=hue;
    ntsccol=n;
    WritePalette();  
}
//-------------------------------------------------------------------------------------------------------------------------------------
void FCEUD_SetPalette(Uint8 index, Uint8 r, Uint8 g, Uint8 b)
{
//    saturn_palette[index] = C_RGB(r>>3,g>>3,b>>3);
    saturn_palette[index] = C_RGB(r,g,b);
}
//-------------------------------------------------------------------------------------------------------------------------------------
void WritePalette(void)
{
    unsigned int x;
    
    for(x=0;x<64;x++)
        FCEUD_SetPalette(x,palo[x].r,palo[x].g,palo[x].b);
}
//-------------------------------------------------------------------------------------------------------------------------------------

#define JOY_A   1
#define JOY_B   2
#define JOY_SELECT      4
#define JOY_START       8
#define JOY_UP  0x10
#define JOY_DOWN        0x20
#define JOY_LEFT        0x40
#define JOY_RIGHT       0x80

//-------------------------------------------------------------------------------------------------------------------------------------
Uint32 update_input(void)
{
//    memset(&input, 0, sizeof(t_input));
    static Uint16 pad_asign[]={
	PER_DGT_U,
	PER_DGT_D,
	PER_DGT_R,
	PER_DGT_L,
	PER_DGT_A,
	PER_DGT_B,
//	PER_DGT_C,
	PER_DGT_S,
//	PER_DGT_X,
//	PER_DGT_Y,
//	PER_DGT_Z,
	PER_DGT_TR,
	PER_DGT_TL,
};
	Bool result;
//	char toto[50];
	unsigned int i=0;
	result = FALSE;
	
     Uint32 JS=0;
      int x,y;
    
     x=y=0;

	 PER_GetPort(__port);	

if(( device = PER_GetDeviceR( &__port[0], 0 )) != NULL )
{
	pltriggerE[0] = pltrigger[0];
	pltrigger[0]  = PER_GetTrigger( device );
	pltriggerE[0] = (pltrigger[0]) ^ (pltriggerE[0]);
	pltriggerE[0] = (pltrigger[0]) & (pltriggerE[0]);

			for(i=0;i<9;i++)
			{
           		if((pltrigger[0] & pad_asign[i])!=0)
			    {			   
//                   switch(pad_asign[i])
                   switch(pltrigger[0] & pad_asign[i] )
	               {
	                    case PER_DGT_U: 
		                y|= JOY_UP;
			            break;

			            case PER_DGT_D:
		                y|= JOY_DOWN;
			            break;

			            case PER_DGT_R:
		                x|= JOY_RIGHT;
			            break;

			            case PER_DGT_L:
		                x|= JOY_LEFT;
			            break;

			            case PER_DGT_A:
//			            FCEU_printf("BUTTON A");
		                JS|=JOY_A<<JoySwap;
			     		break;

			            case PER_DGT_B:
//			            FCEU_printf("BUTTON B");
		                JS |=JOY_B<<JoySwap;
						break;

			      		case PER_DGT_C:
//			            FCEU_printf("BUTTON SELECT");									      		
			      		JS |= JOY_SELECT<<JoySwap;
		    			break;
		
						case PER_DGT_S:
//			            FCEU_printf("BUTTON START");						
						JS |= JOY_START<<JoySwap;
						break;

			            case PER_DGT_TR:
		            	break;

					    case PER_DGT_TL:
						break;
					}
				}
              }					
		}
		else{
			pltrigger[0] = pltriggerE[0] = 0;
		}
		
    if(y!=(JOY_DOWN|JOY_UP)) JS|=y<<JoySwap;
    if(x!=(JOY_LEFT|JOY_RIGHT)) JS|=x<<JoySwap;		

    return JS;
}
//-------------------------------------------------------------------------------------------------------------------------------------
#define	REGADDR	0x25F80000

 void SCL_CopyReg2()
{
//	Uint16	i;
	Uint16 *regaddr = (Uint16 *)REGADDR;
//    i = 0x14;

	if(!play)
	{
		regaddr[0] = Scl_s_reg.tvmode;		/* add				by C.Y	*/
		regaddr[1] = Scl_s_reg.extenbl;		/* add				by C.Y	*/
		regaddr[3] = Scl_s_reg.vramsize;		/* add				by C.Y	*/
		SCL_Memcpyw( &regaddr[7] , &Scl_s_reg.ramcontrl , 26 );
	    SCL_Memcpyw(&regaddr[0x14], &Scl_d_reg, sizeof(SclDataset));
	}

//    i += sizeof(SclSysreg) >>1;
//    i += 0x14;
//	if (!play)

//    i += sizeof(SclDataset) >>1;
//	i+=0x24;
    SCL_Memcpyw(&regaddr[0x38], &Scl_n_reg, sizeof(SclNorscl));
	if (SclProcess==2)
	{
//		i += sizeof(SclNorscl) >>1;
//		i += sizeof(SclRotscl) >>1;
//		i += 0x28;
		SCL_Memcpyw(&regaddr[0x60], &Scl_w_reg, sizeof(SclWinscl));
	}
//    i += sizeof(SclWinscl) / 2;
}


void  SCL_PriIntProc2(void)
{
    if(SclPriBuffDirty.SclOtherPri){ //nbg
		SCL_Memcpyw((SclOtherPriRegister *)0x25F800E0, &SclOtherPri, sizeof(SclOtherPri));
		SclPriBuffDirty.SclOtherPri = 0;
    }
    if(SclPriBuffDirty.SclSpPriNum){ //sprites
		SCL_Memcpyw((SclSpPriNumRegister *)0x25F800F0, &SclSpPriNum, sizeof(SclSpPriNum));
		SclPriBuffDirty.SclSpPriNum = 0;
    }
    if(SclPriBuffDirty.SclBgPriNum){//nbg
		SCL_Memcpyw((SclBgPriNumRegister *)0x25F800F8, &SclBgPriNum, sizeof(SclBgPriNum));
		SclPriBuffDirty.SclBgPriNum = 0;
    }
    return;
}

void	SCL_ScrollShow2(void)
{

    switch(SclProcess){
	    case 1:
		SCL_CopyReg2();
		SclProcess = 0;
		break;
	    case 2:			/* line scroll setting */
//		SCL_Memcpyw((void *)SclAddrLsTbl[0],(void *)SclAddrLsTbl[1], 0x400);
		SCL_CopyReg2();
		SclProcess = 0;
		break;
		default:
		break;
    }

    SCL_PriIntProc2();
}


