/********************************************************/
/*******		sound.c				*/
/*******						*/
/*******  Sound emulation code and waveform synthesis 	*/
/*******  routines.  A few ideas were inspired		*/
/*******  by code from Marat Fayzullin's EMUlib		*/
/*******						*/
/********************************************************/		

#include <stdlib.h>
#include <stdio.h>

#include <string.h>

#include "types.h"
#include "x6502.h"
#include "fce.h"
//#include "sound.h"

uint8 PSG[0x18];
uint32 soundtsinc;
uint8 sqnon=0;

uint8 SIRQStat=0;
//uint8 fcnt=0;
//int32 fhcnt=0;
//int32 fhinc;

static DECLFW(Write0x11)
{
    PSG[0x11]=V&0x7F;
}

static DECLFW(Write_PSG)
{
    A&=0x1f;
    switch(A)
    {
        case 0x0: case 0x1: 
        case 0x2: case 0x3:
        case 0x4: case 0x5: 
        case 0x6: case 0x7: 
        case 0x8: case 0xa:
        case 0xb: case 0xC: 
        case 0xE: case 0xF: break;
        case 0x10:

	    if(!(V&0x80))
    	    X6502_IRQEnd(FCEU_IQDPCM);
	    break;
	    
        case 0x13:break;
        case 0x15:
            X6502_IRQEnd(FCEU_IQDPCM);
        break;
           
        case 0x17: 
    	    V&=0xC0;
//            fcnt=0;      
            
//            if(V&0x80)
//                FrameSoundUpdate();
            
            X6502_IRQEnd(FCEU_IQFCOUNT);
            SIRQStat&=~0x40;	   
        break;
    }
    PSG[A]=V;
}

DECLFR(Read_PSG)
{
   uint8 ret;

   ret=(PSG[0x15]&(sqnon|0x10))|SIRQStat;
   
   SIRQStat&=~0x40;
   X6502_IRQEnd(/*FCEU_IQDPCM|*/FCEU_IQFCOUNT);
   return ret;
}

DECLFR(Read_PSGDummy)
{
   uint8 ret;

   ret=(PSG[0x15]&sqnon)|SIRQStat;
   SIRQStat&=~0x40;
   X6502_IRQEnd(/*FCEU_IQDPCM|*/FCEU_IQFCOUNT);
   return ret;
}

void SetNESSoundMap(void)
{ 
  SetWriteHandler(0x4000,0x4013,Write_PSG);
  SetWriteHandler(0x4011,0x4011,Write0x11);
  SetWriteHandler(0x4015,0x4015,Write_PSG);
  SetWriteHandler(0x4017,0x4017,Write_PSG);        
  SetReadHandler(0x4015,0x4015,Read_PSG);
}
